/* *****************************************************************************
  HD4470n(SC1602BS*B) tW[pR[h @@'061216 '041217 im
  Kusunoki Masahirô̂ꕔύX
@LCDread͍s킸delayŃ^C~OĂ̂Ł@read֌W͍폜.n[h
  EGAGNDɐڑĂ
@'050225@WinAVR20050214Ή̂ @cbi@sbi@outp@inp@B
  '061216  f[^̃rbgwLɂ   (by )
  '070601  CGRAMփf[^lcd_putramǉ   (by )
  '070908  PIC24Fpɉ (by )
  '070922  lcd_putstrvoid *ɕύX (by )
******************************************************************************* */
#include "p24FJ64GA002.h"
#include "lcd.h"

uint8_t columns;
uint8_t lines;

void lcd_delay(void) {
  uint16_t i;

  //8MHzł5000ok, 16MHzł10000ok, 32MHzł20000ok
  for(i = 20000; i--; ) {
    asm("NOP");
  }
}

void lcd_e(void) {//ẼpX230nsecȏKv
  LCD_CTL_PORT|=_BV(LCD_E);    // E = Hi
  asm("NOP");//62nsec(32MHz/2)
  asm("NOP");//62nsec
  asm("NOP");//62nsec
  asm("NOP");//62nsec
  LCD_CTL_PORT&=~_BV(LCD_E);   // E = Low
}

void lcd_cls(void) {
  columns = lines = 0;
  lcd_putcmd(0x01);
}

void lcd_gotopos(uint8_t col,uint8_t lin) {

  switch(lin) {
  case 0: lcd_putcmd(0x80 + col); break;
  case 1: lcd_putcmd(0xC0 + col); break;
  }
  columns = col;
  lines = lin;
}

void lcd_setpos(void) {
  columns = 0;
  switch(++lines) {
  case 2: lines = 0;  lcd_putcmd(0x80); break;
  case 1: lcd_putcmd(0xC0); break;
  }
}

void lcd_cmdout_s(uint8_t cmd) {
  uint16_t wk;
  LCD_CTL_PORT&=~_BV(LCD_RS);   // RS = Low
//  LCD_CTL_PORT&=~_BV(LCD_RW);   // RW = Low
  wk=LCD_DATA_PORT;             // o̓|[gǂł

  wk &= ~(_BV(LCD_D7) | _BV(LCD_D6) | _BV(LCD_D5) | _BV(LCD_D4));//f[^rbgNA
  wk |= ((cmd & 0x1)==0x1) ? _BV(LCD_D4):0;//bit4
  wk |= ((cmd & 0x2)==0x2) ? _BV(LCD_D5):0;//bit5
  wk |= ((cmd & 0x4)==0x4) ? _BV(LCD_D6):0;//bit6
  wk |= ((cmd & 0x8)==0x8) ? _BV(LCD_D7):0;//bit7

  LCD_DATA_PORT=wk;
  lcd_e();
}

void lcd_putcmd(uint8_t cmd) {
  lcd_cmdout_s(cmd >> 4);
  lcd_cmdout_s(cmd & 0x0F);
  lcd_delay();
}

void lcd_dataout_s(uint8_t ch) {
  uint16_t wk;
  LCD_CTL_PORT|=_BV(LCD_RS);   // RS = Hi
//  LCD_CTL_PORT&=~_BV(LCD_RW);   // RW = Low
  wk=LCD_DATA_PORT;            // o̓|[gǂł

  wk &= ~(_BV(LCD_D7) | _BV(LCD_D6) | _BV(LCD_D5) | _BV(LCD_D4));//f[^rbgNA
  wk |= ((ch & 0x1)==0x1) ? _BV(LCD_D4):0;//bit4
  wk |= ((ch & 0x2)==0x2) ? _BV(LCD_D5):0;//bit5
  wk |= ((ch & 0x4)==0x4) ? _BV(LCD_D6):0;//bit6
  wk |= ((ch & 0x8)==0x8) ? _BV(LCD_D7):0;//bit7

  LCD_DATA_PORT=wk;

  lcd_e();
}

void lcd_putch(uint8_t ch) {

  lcd_dataout_s(ch >> 4);
  lcd_dataout_s(ch & 0x0F);
  lcd_delay();
  if(++columns == LCD_COL) {
    lcd_setpos();
  }
}

void lcd_putstr(void *str) {
  while(*(uint8_t *)str) {
    lcd_putch(*(uint8_t *)str++);
  }
}

void lcd_init(void) {

  //IO pin 
  LCD_CTL_PORT_DDR &= ~((1<<LCD_RS) | (1<<LCD_E) /* | (1<<LCD_RW) */);//out
  LCD_DATA_PORT_DDR &= ~((1<<LCD_D7) | (1<<LCD_D6) | (1<<LCD_D5) | (1<<LCD_D4));//out

  lcd_delay();
  lcd_delay();
  lcd_delay();
  lcd_delay();

  LCD_CTL_PORT&=~_BV(LCD_RS);    // RS = Low
  LCD_CTL_PORT&=~_BV(LCD_E);     // E  = Low

  lcd_cmdout_s(0x03);
  lcd_delay();
  lcd_cmdout_s(0x03);
  lcd_delay();
  lcd_cmdout_s(0x03);
  lcd_delay();
  lcd_cmdout_s(0x02);
  lcd_delay();
  lcd_putcmd(0x28);
  lcd_putcmd(0x08);
  lcd_putcmd(0x01);
  lcd_putcmd(0x0C);
  columns = 0;
  lines = 0;
}

void lcd_putram(uint8_t code, uint8_t *dat)
{
  uint8_t i;

  code &= 7;//CGRAM07܂8
  lcd_putcmd(0x40+(code<<3));//CGRAM AddressZbgiȍ~CGRAMf[^j

  for(i=0;i<8;i++){
    lcd_dataout_s(*dat >> 4);
    lcd_delay();
    lcd_dataout_s(*dat & 0x0F);
    lcd_delay();
    dat++;
  }

  lcd_gotopos(columns, lines);//f[^DDRAMɖ߂
}
